package com.sun.corba.se.impl.dynamicany;

import org.omg.DynamicAny.DynAnyPackage.InvalidValue;
import org.omg.DynamicAny.DynAnyPackage.TypeMismatch;
import org.omg.CORBA.portable.OutputStream;
import org.omg.CORBA.ORBPackage.InvalidName;
import org.omg.DynamicAny.DynAnyFactory;
import org.omg.CORBA.TypeCode;
import org.omg.CORBA.Any;
import com.sun.corba.se.impl.logging.ORBUtilSystemException;
import com.sun.corba.se.spi.orb.ORB;
import org.omg.DynamicAny.DynAny;
import org.omg.CORBA.LocalObject;

abstract class DynAnyImpl extends LocalObject implements DynAny
{
    protected static final int NO_INDEX = -1;
    protected static final byte STATUS_DESTROYABLE = 0;
    protected static final byte STATUS_UNDESTROYABLE = 1;
    protected static final byte STATUS_DESTROYED = 2;
    protected ORB orb;
    protected ORBUtilSystemException wrapper;
    protected Any any;
    protected byte status;
    protected int index;
    private String[] __ids;
    
    protected DynAnyImpl() {
        this.orb = null;
        this.any = null;
        this.status = 0;
        this.index = -1;
        this.__ids = new String[] { "IDL:omg.org/DynamicAny/DynAny:1.0" };
        this.wrapper = ORBUtilSystemException.get("rpc.presentation");
    }
    
    protected DynAnyImpl(ORB orb, Any any, boolean b) {
        this.orb = null;
        this.any = null;
        this.status = 0;
        this.index = -1;
        this.__ids = new String[] { "IDL:omg.org/DynamicAny/DynAny:1.0" };
        this.orb = orb;
        this.wrapper = ORBUtilSystemException.get(orb, "rpc.presentation");
        if (b) {
            this.any = DynAnyUtil.copy(any, orb);
        }
        else {
            this.any = any;
        }
        this.index = -1;
    }
    
    protected DynAnyImpl(ORB orb, TypeCode typeCode) {
        this.orb = null;
        this.any = null;
        this.status = 0;
        this.index = -1;
        this.__ids = new String[] { "IDL:omg.org/DynamicAny/DynAny:1.0" };
        this.orb = orb;
        this.wrapper = ORBUtilSystemException.get(orb, "rpc.presentation");
        this.any = DynAnyUtil.createDefaultAnyOfType(typeCode, orb);
    }
    
    protected DynAnyFactory factory() {
        try {
            return (DynAnyFactory)this.orb.resolve_initial_references("DynAnyFactory");
        }
        catch (InvalidName invalidName) {
            throw new RuntimeException("Unable to find DynAnyFactory");
        }
    }
    
    protected Any getAny() {
        return this.any;
    }
    
    protected Any getAny(DynAny dynAny) {
        if ((dynAny instanceof DynAnyImpl)) {
            return ((DynAnyImpl)dynAny).getAny();
        }
        return dynAny.to_any();
    }
    
    protected void writeAny(OutputStream outputStream) {
        this.any.write_value(outputStream);
    }
    
    protected void setStatus(byte status) {
        this.status = status;
    }
    
    protected void clearData() {
        this.any.type(this.any.type());
    }
    
    public TypeCode type() {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        return this.any.type();
    }
    
    public void assign(DynAny dynAny) throws TypeMismatch {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any != null && !this.any.type().equal(dynAny.type())) {
            throw new TypeMismatch();
        }
        this.any = dynAny.to_any();
        return;
    }
    
    public void from_any(Any any) throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any != null && !this.any.type().equal(any.type())) {
            throw new TypeMismatch();
        }
        Any copy;
        try {
            copy = DynAnyUtil.copy(any, this.orb);
        }
        catch (Exception ex) {
            throw new InvalidValue();
        }
        if (!DynAnyUtil.isInitialized(copy)) {
            throw new InvalidValue();
        }
        this.any = copy;
        return;
    }
    
    public abstract Any to_any();
    
    public abstract boolean equal(DynAny p0);
    
    public abstract void destroy();
    
    public abstract DynAny copy();
    
    public String[] _ids() {
        return (String[])(String[])this.__ids.clone();
    }
}
